summaryrefslogtreecommitdiffabout
path: root/delta.jscad
authorMichael Krelin <hacker@klever.net>2016-03-20 14:38:17 (UTC)
committer Michael Krelin <hacker@klever.net>2016-03-20 14:38:17 (UTC)
commit8805ba36fd9da26d3764ad83a5c8b97c30140dc0 (patch) (side-by-side diff)
tree0c98aaa8b3c9c967285dfb1f535113b2afb67959 /delta.jscad
parent33c7b3b1dc1d7d9c706bfa25e9f56eb237aa7dfc (diff)
downloadredelta-8805ba36fd9da26d3764ad83a5c8b97c30140dc0.zip
redelta-8805ba36fd9da26d3764ad83a5c8b97c30140dc0.tar.gz
redelta-8805ba36fd9da26d3764ad83a5c8b97c30140dc0.tar.bz2
bed holder redesign
Diffstat (limited to 'delta.jscad') (more/less context) (ignore whitespace changes)
-rw-r--r--delta.jscad53
1 files changed, 53 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad
index 12bdb97..e9fb773 100644
--- a/delta.jscad
+++ b/delta.jscad
@@ -708,192 +708,245 @@ function shoe() {
function duetholder() {
var DH = CONFIG.duetholder;
var DHD = CD.duetholder;
var hw = DH.bolt.head.d+2*DH.margin;
var s = DH.bolt.l-CONFIG.extrusion.slotdepth+PRINT.play_tolerance*2;
var lower = CONFIG.foot.h-2*DH.s;
var hl = DHD.distance-CONFIG.extrusion.w;
var rv = union([
CSG.cube({ // vertical
corner1: [-hw/2,s,CONFIG.extrusion.w],
corner2: [hw/2,0,-lower]
}),
CSG.cube({ // horizontal extrusion
corner1: [-hw/2,-CONFIG.extrusion.w,0],
corner2: [ hw/2,0,-s]
}),
CSG.cube({ // horizontal
corner1: [-hw/2,0,-lower],
corner2: [hw/2,hl,-lower+DH.s]
}),
CSG.cylinder({ // boltend of horizontal part
start: [0,hl,-lower], end: [0,hl,-lower+DH.s],
radius: hw/2
})
]);
rv = rv.subtract([
CSG.cylinder({ // through vertical
start: [0,-1,CONFIG.extrusion.w/2], end: [0,s+1,CONFIG.extrusion.w/2],
radius: DH.bolt.d/2+PRINT.slide_tolerance
}),
CSG.cylinder({ // through horizontal to extrusion
start: [0,-CONFIG.extrusion.w/2,-s-1],
end: [0,-CONFIG.extrusion.w/2,1],
radius: DH.bolt.d/2+PRINT.slide_tolerance
}),
CSG.cube({ // cut off
corner1: [-hw/2-1,-2*s,0],
corner2: [hw/2+1,0,-2*s]
}).rotateX(45).translate([0,-CONFIG.extrusion.w,0]),
CSG.cylinder({ // duet bolt
start: [0,hl,-lower], end: [0,hl,-lower+DH.s],
radius: DH.bolt.d/2+PRINT.slide_tolerance
})
]);
var cp = [0,hl,-lower+DH.s];
rv.properties.duet = new CSG.Properties();
rv.properties.duet.c_sw = new CSG.Connector(cp,[0,0,1],[1,0,0]);
rv.properties.duet.c_se = new CSG.Connector(cp,[0,0,1],[1,0,0]);
rv.properties.duet.c_ne = new CSG.Connector(cp,[0,0,1],[-Math.cos(Math.PI/3),-Math.sin(Math.PI/3),0]);
rv.properties.duet.c_nw = new CSG.Connector(cp,[0,0,1],[-Math.cos(Math.PI/3),Math.sin(Math.PI/3),0]);
rv.properties.c_h = new CSG.Connector([0,-CONFIG.extrusion.w/2,0],[0,0,1],[1,0,0]);
rv.properties.c_v = new CSG.Connector([0,0,CONFIG.extrusion.w/2],[0,-1,0],[0,0,1]);
rv.properties.P = new CSG.Connector([-hw/2,0,0],[1,0,0],[0,1,0]);
return rv.setColor(CONFIG.color.parts);
}
function heatbed() {
var rv = CSG.cylinder({
start: [0,0,0], end: [0,0,CONFIG.heatbed.h],
radius: CONFIG.heatbed.r, resolution: 72
});
var screw = CSG.cylinder({
start: [0,-CONFIG.heatbed.sr,-1],
end: [0,-CONFIG.heatbed.sr,CONFIG.heatbed.h+1],
radius: 3/2
});
var screws = [];
for(var a=0;a<360;a+=60) screws.push(screw.rotateZ(a)); // TODO: connectors
rv = rv.subtract(screws);
rv.properties.c_glass = new CSG.Connector([0,0,CONFIG.heatbed.h],[0,0,1],[1,0,0]);
rv.properties.P = new CSG.Connector(
[0,0,-CONFIG.foot.h-CONFIG.extrusion.w*2-CONFIG.base.gap-CONFIG.bedholder.h],
[0,0,1],[1,0,0]);
rv.properties.vitamin = true;
return rv.setColor(CONFIG.color.heatbed);
}
function glass() {
var rv = CSG.cylinder({
start: [0,0,0], end: [0,0,CONFIG.glass.h],
radius: CONFIG.glass.r, resolution: 72
});
rv.properties.c_bed = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
rv.properties.P = new CSG.Connector([0,0,-CONFIG.foot.h-CONFIG.heatbed.h],[0,0,1],[1,0,0]);
rv.properties.vitamin = true;
return rv.setColor(CONFIG.color.glass);
}
function platform() {
var b = heatbed();
var g = glass();
g = g.connectTo(g.properties.c_bed,b.properties.c_glass,false,0);
return b.union(g);
}
function bedholder(params) {
var h0 = CONFIG.foot.h+CONFIG.extrusion.w*2+CONFIG.base.gap;
+ var e_h=E2020.T.thickness; // height of the bump for extrusion
+ var e_w=E2020.slot_width-PRINT.fit_tolerance; // width of the bump for extrusion
+ var e_o=E2020.slot_width+PRINT.fit_tolerance; // opening for the T-Nut width
+ var rv = CSG.cylinder({
+ start: [0,0,h0], end: [0,0,h0+CONFIG.bedholder.h],
+ radiusStart: CD.base.outer_inscription_r,
+ radiusEnd: CD.base.outer_inscription_r+CONFIG.bedholder.h/2,
+ resolution: 240
+ });
+ rv=rv.intersect(CSG.cube({
+ corner1: [-CONFIG.extrusion.w/2,-CD.base.inner_inscription_r,h0],
+ corner2: [ CONFIG.extrusion.w/2,-CD.base.mid_inscription_r*2,h0+2*CONFIG.bedholder.h]
+ }));
+
+ rv=rv.union(CSG.cube({ // bump to fix on extrusion
+ corner1: [-CONFIG.extrusion.w/2,-CD.base.mid_inscription_r-e_w/2,h0],
+ corner2: [ CONFIG.extrusion.w/2,-CD.base.mid_inscription_r+e_w/2,h0-e_h]
+ }).subtract(
+ CSG.cube({center:[0,0,0],radius:[(e_o+2*e_h)/(2*Math.sqrt(2)),e_w+2,(e_o+2*e_h)/(2*Math.sqrt(2))]})
+ .rotateY(45)
+ .translate([0,-CD.base.mid_inscription_r,h0-e_h])
+ ));
+
+ var ebolt_s = CONFIG.bedholder.bolt.l-CONFIG.extrusion.slotdepth+PRINT.play_tolerance*2;
+ rv=rv.subtract([
+ CSG.cylinder({ // base screw
+ start: [0,-CD.base.mid_inscription_r,h0-1],
+ end: [0,-CD.base.mid_inscription_r,h0+CONFIG.bedholder.h+1],
+ radius: CONFIG.bedholder.bolt.d/2+PRINT.screw_tolerance/2
+ }),
+ CSG.cylinder({ // base screw head
+ start: [0,-CD.base.mid_inscription_r,h0+ebolt_s],
+ end: [0,-CD.base.mid_inscription_r,h0+CONFIG.bedholder.h+1],
+ radius: CONFIG.bedholder.bolt.head.d/2+PRINT.play_tolerance
+ })
+ ]);
+
+ var nuth=h0+CONFIG.bedholder.h*3/4;
+ rv=rv.subtract([
+ CSG.cylinder({ // bed screw
+ start: [0,-CONFIG.heatbed.sr,h0-1],
+ end: [0,-CONFIG.heatbed.sr,h0+CONFIG.bedholder.h+1],
+ radius: CONFIG.bedholder.bolt.d/2+PRINT.screw_tolerance/2
+ }),
+ CSG.cube({ // nut pocket
+ center: [0,-CONFIG.heatbed.sr,nuth],
+ radius: [CONFIG.extrusion.w/2+1,CONFIG.bedholder.nut.w/2+PRINT.slide_tolerance/2,CONFIG.bedholder.nut.h/2+PRINT.slide_tolerance/2]
+ })
+ ]);
+
+ rv.properties.P = new CSG.Connector([-CONFIG.extrusion.w/2,-CD.base.mid_inscription_r,h0+CONFIG.bedholder.h/2],
+ [1,0,0],[0,0,1]);
+ return rv.setColor(CONFIG.color.parts);
var bolt_s = CONFIG.bedholder.bolt.l-CONFIG.extrusion.slotdepth+PRINT.play_tolerance*2;
var nuth=h0+CONFIG.bedholder.h*3/4;
var nutth = nuth+CONFIG.bedholder.nut.h/2+PRINT.slide_tolerance/2;
var rv = CSG.roundedCube({
corner1: [-CONFIG.extrusion.w/2,-CD.base.inner_inscription_r,h0],
corner2: [ CONFIG.extrusion.w/2,-CONFIG.heatbed.sr-3/2-CONFIG.bedholder.margin,h0+CONFIG.bedholder.h],
roundradius: CONFIG.bedholder.margin
});
rv = rv.subtract([
CSG.cylinder({ // base screw
start: [0,-CD.base.mid_inscription_r,h0-1],
end: [0,-CD.base.mid_inscription_r,h0+CONFIG.bedholder.h+1],
radius: CONFIG.bedholder.bolt.d/2+PRINT.screw_tolerance/2
}),
CSG.cylinder({ // bed screw
start: [0,-CONFIG.heatbed.sr,h0-1],
end: [0,-CONFIG.heatbed.sr,h0+CONFIG.bedholder.h+1],
radius: CONFIG.bedholder.bolt.d/2+PRINT.screw_tolerance/2
}),
CSG.cube({ // nut pocket
center: [0,-CONFIG.heatbed.sr,nuth],
radius: [CONFIG.extrusion.w/2+1,(CONFIG.bedholder.nut.w+PRINT.slide_tolerance)/2,(CONFIG.bedholder.nut.h+PRINT.slide_tolerance)/2]
}),
CSG.cylinder({ // sink base screw
start: [0,-CD.base.mid_inscription_r,h0+bolt_s],
end: [0,-CD.base.mid_inscription_r,h0+CONFIG.bedholder.h+1],
radius: CONFIG.bedholder.bolt.head.d/2+PRINT.play_tolerance
})
]);
rv = rv.union(CSG.cylinder({ // patch up for bridging
start: [0,-CONFIG.heatbed.sr,nutth], end: [0,-CONFIG.heatbed.sr,nutth+PRINT.layer_height],
radius: (CONFIG.bedholder.nut.w+PRINT.slide_tolerance)/2+PRINT.extrusion_width
}));
rv = rv.intersect(CSG.cylinder({ // cut off excess
start: [0,0,h0-1], end: [0,0,h0+CONFIG.bedholder.h+1],
radius: CONFIG.heatbed.r, resolution: 270
}));
rv.properties.P = new CSG.Connector([0,-CD.base.mid_inscription_r,h0],[0,0,1],[1,0,0]);
return rv.setColor(CONFIG.color.parts);
}
var PARTS = {
wip: function(params) {
return duetholder(params);
return PARTS.alltogethernow(params);
return base_extrusions();
return foot();
return union(base_extrusions(),column_extrusions(),duet().translate([0,-20,0]));
},
alltogethernow: function(params) {
var cols = columns();
var sides = base_sides();
var feet = THREEWINDS.map(function(w,i) {
var rv = foot();
rv = rv.connectTo(rv.properties.c_column,cols[i].properties.c_bottom,false,0);
var s = shoe();
s = s.connectTo(s.properties.c_foot,rv.properties.c_shoe,false,0);
return rv.union(s);
});
var dh = duetholder();
var dhsw = dh.connectTo(dh.properties.c_h,
new CSG.Connector([-CONFIG.duet.hole_spacing.x/2,-CD.base.mid_inscription_r,CONFIG.foot.h],[0,0,1],[1,0,0]),
false,0);
var d = duet();
d = d.connectTo(d.properties.holes.c_sw,dhsw.properties.duet.c_sw,false,0);
var dhse = dh.connectTo(dh.properties.duet.c_se,d.properties.holes.c_se,false,0);
var dhne = dh.connectTo(dh.properties.duet.c_ne,d.properties.holes.c_ne,false,0);
var dhnw = dh.connectTo(dh.properties.duet.c_nw,d.properties.holes.c_nw,false,0);
var rv = union(cols).union(sides.map(union)).union(feet).union([
d,dhsw,dhse,dhne,dhnw
]);
var p = U.P(platform());
rv = rv.union(p);
rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv;
},
duetholder: function(params) {
return duetholder();
},
foot: foot,
shoe: shoe,
bedholder: bedholder,
platform: function(params) { return U.P(EFFECTOR.effector()) },
hinged: function(params) {
// TODO: handle print mode
var ms = microswitch();
var e = EFFECTOR.effector();
var hd = EFFECTOR.hinged({
microswitch:ms,effector:e
});
ms = ms.connectTo(
ms.properties.screw_connector[0],
hd.properties.microswitch_screw_connector[0],
false, 0);
var hdhd = EFFECTOR.split_hinged(hd);
return U.P(hdhd[1]);